#include <config.h>

/* we'll disable this example if that static GtkMenuEntry thingy does not
   work on people's C++ compilers. At least solaris CC has such problems */

#include <testgtkmm.h>

static GtkMenuEntry menu_items[] =
{
    {"<Main>/File/New", 0, 0, 0},
    {"<Main>/File/Open", 0, 0, 0},
    {"<Main>/File/Save", 0, 0, 0},
    {"<Main>/File/<separator>", 0, 0, 0},
    {"<Main>/Options/A", 0, 0, 0},
    {"<Main>/Options/B", 0, 0, 0},
    {"<Main>/File/test/A", 0, 0, 0},
    {"<Main>/File/test/B", 0, 0, 0},
    {"<Main>/File/test/C", 0, 0, 0},
    {"<Main>/File/<separator>", 0, 0, 0},
    {"<Main>/File/Quit", 0, 0, 0}
};
static int nmenu_items = sizeof(menu_items)/sizeof(menu_items[0]);


togglebuttontest::togglebuttontest() 
    : tb("togglebutton"), 
      tb2("toggle2") { 
    tb.set_state(true);
    tb2.set_state(false);
    tb.show();
    tb2.show();
    add(&tb);
    add(&tb2);
}

menufactorytest::menufactorytest() : mf(GTK_MENU_FACTORY_MENU_BAR),
    subfactory(GTK_MENU_FACTORY_MENU_BAR) {
	mf.add_subfactory(&subfactory,"<Main>");
	mf.add_entries(menu_items,nmenu_items);
	mb=new Gtk_MenuBar(GTK_MENU_BAR(subfactory.gtkobj()->widget));
	add(mb);
	mb->show();
}


test::test() {
    Gtk_Window::add(&vbox);
    set_usize(200,100);
    vbox.show();
    vbox.pack_start(&hsep);
    vbox.pack_start(&closebutton);
}

chooser::chooser() {
    add(&vbox);
    vbox.show();
}


void chooser::add_item(const char *name, test *w)
{
    Gtk_Button *b=new Gtk_Button(name);
    vbox.pack_start(b,TRUE,FALSE,0);
    b->show();
    w->set_title(name);
    connect_to_signal(b->clicked, w->show);
}

gint test::delete_event_impl(GdkEventAny* e) 
{
    hide();
    return 1;
}
gint chooser::delete_event_impl(GdkEventAny *)
{
    hide();
    Gtk_Main::instance()->quit();
    return 1;
}

void main(int argc, char *argv[]) {
    Gtk_Main m(&argc, &argv);
    chooser c;
    c.add_item("menufactory",new menufactorytest);
    c.add_item("togglebutton",new togglebuttontest);
    c.set_usize(200,100);
    c.show();
    m.run();
}






















